require 'webrick/httpauth/htdigest'
require 'mutual'

module WEBrick
  module HTTPAuth
    class Htmutual < Htdigest
      def initialize(path)
        super(path)
        @auth_type = MutualAuth
      end

      def set_passwd(conf, user, pass)
        realm = conf[:Realm]
        @mutex.synchronize{
          @digest[realm] ||= Hash.new
          @digest[realm][user] = make_passwd(conf, user, pass)
        }
      end
    end
  end
end
