
module BrokenAuth
  class Base
    def initialize(auth, option, logger)
      @auth = auth
      @option = option || {}
      @logger = logger
      @count = 0
      @@list ||= []
      @@list << self
    end
    attr_reader :auth, :option, :logger

    def authenticate(req, res)
      use = true
      use = false if @option["OneShot"] && @count > 0
      pre_authenticate(req, res) if use
      begin
        auth.authenticate(req, res)
      ensure
        post_authenticate(req, res) if use
      end
    end

    def pre_authenticate(req, res)
    end
    def post_authenticate(req, res)
    end

    def self.reset
      @@list.each {|x| x.reset }
    end
    
    def reset
      @count = 0
    end
  end

  class ModifyOb < Base
    def post_authenticate(req, res)
      STDERR.puts "\n\n\n\n\n\n\n\n\n\n ModifyOb \n\n\n\n\n\n\n\n\n\n"
      if res["Authentication-Info"]
        puts "vks_before = " + res["Authentication-Info"]
        res["Authentication-Info"].sub!(/vks=\"?./) {|s|
          @count += 1
          ob0 = s[-1,1]
          ob0.tr!('0-9', '1-90')
          ob0.tr!('a-f', 'b-fa')
          ob0.tr!('A-F', 'B-FA')
          ob0.tr!('g-zG-Z+/', 'h-zG-Z+/g')
          s[-1] = ob0
          s
        }
        puts "vks_after = " + res["Authentication-Info"]
      end
    end
  end

  class ModifyZ < Base
    def pre_authenticate(req, res)
      if req["Authorization"] && req["Authorization"] =~ /sid=(['"0-9a-fA-F]+)/ # '
        @count += 1
        sid = $1.gsub(/['"]/, '') #'
        @auth.instance_eval {
          s = @sessions[sid]
          if s
            s.z >>= 1
          end
        }
      end
    end
  end

  class ClearSession < Base
    def pre_authenticate(req, res)
      if req["Authorization"] && req["Authorization"] =~ /sid=(['"0-9a-fA-F]+)/ # '
        @count += 1
        sid = $1.gsub(/['"]/, '') #'
        @auth.instance_eval {
          @sessions.delete(sid)
        }
      end
    end
  end

  class ModifyRandom < Base
    def post_authenticate(req, res)
      @count += 1
      modify(res["Authentication-Info"]) if rand(3) == 0
      modify(res["WWW-Authenticate"])
    end

    def modify(s)
      if s
        1.times {|n|
          i = rand(s.size)
          s[i] ^= 1
        }
        logger.info("ModifyRandom: #{s}")
      end
    end
  end

  class ResetConnectionA1 < Base
    def pre_authenticate(req, res)
      if req["Authorization"] && req["Authorization"] =~ /wa=/
        @count += 1
        req.instance_eval {
          @socket.close
        }
      end
    end
  end

  class ResetConnectionA3 < Base
    def pre_authenticate(req, res)
      if req["Authorization"] && req["Authorization"] =~ /sid=/
        @count += 1
        req.instance_eval {
          @socket.close
        }
      end
    end
  end
end

def wrap_broken_auth(auth, cls_name, opt, logger)
  cls = BrokenAuth.const_get(cls_name)
  cls.new(auth, opt, logger)
end

def reset_broken_auth
  BrokenAuth::Base.reset
end
